/**
 * Mandelbulber v2, a 3D fractal generator  _%}}i*<.         ______
 * Copyright (C) 2024 Mandelbulber Team   _>]|=||i=i<,      / ____/ __    __
 *                                        \><||i|=>>%)     / /   __/ /___/ /_
 * This file is part of Mandelbulber.     )<=i=]=|=i<>    / /__ /_  __/_  __/
 * The project is licensed under GPLv3,   -<>>=|><|||`    \____/ /_/   /_/
 * see also COPYING file in this folder.    ~+{i%+++
 */

#ifndef MANDELBULBER2_FORMULA_DEFINITION_ALL_FRACTAL_DEFINITIONS_H_
#define MANDELBULBER2_FORMULA_DEFINITION_ALL_FRACTAL_DEFINITIONS_H_

#include "abstract_fractal.h"

FRACTAL_CLASS(cFractalNone)
FRACTAL_CLASS(cFractalAbox4d)
FRACTAL_CLASS(cFractalAboxDonut4d)
FRACTAL_CLASS(cFractalAboxDonut4dV2)
FRACTAL_CLASS(cFractalAboxKlein)
FRACTAL_CLASS(cFractalAboxMod1)
FRACTAL_CLASS(cFractalAboxMod11)
FRACTAL_CLASS(cFractalAboxMod12)
FRACTAL_CLASS(cFractalAboxMod13)
FRACTAL_CLASS(cFractalAboxMod14)
FRACTAL_CLASS(cFractalAboxMod15)
FRACTAL_CLASS(cFractalAboxMod2)
FRACTAL_CLASS(cFractalAboxModKali)
FRACTAL_CLASS(cFractalAboxModKaliEiffie)
FRACTAL_CLASS(cFractalAboxModKaliV2)
FRACTAL_CLASS(cFractalAboxModKaliV3)
FRACTAL_CLASS(cFractalAboxSmooth)
FRACTAL_CLASS(cFractalAboxSphere4d)
FRACTAL_CLASS(cFractalAboxSurfBox)
FRACTAL_CLASS(cFractalAboxTetra)
FRACTAL_CLASS(cFractalAboxTetra4d)
FRACTAL_CLASS(cFractalAboxVSIcen1)
FRACTAL_CLASS(cFractalAexion)
FRACTAL_CLASS(cFractalAexion4dV2)
FRACTAL_CLASS(cFractalAexionOctopusMod)
FRACTAL_CLASS(cFractalAmazingIfs)
FRACTAL_CLASS(cFractalAmazingSurf)
FRACTAL_CLASS(cFractalAmazingSurfKlein)
FRACTAL_CLASS(cFractalAmazingSurfKleinV2)
FRACTAL_CLASS(cFractalAmazingSurfM3d)
FRACTAL_CLASS(cFractalAmazingSurfMod1)
FRACTAL_CLASS(cFractalAmazingSurfMod2)
FRACTAL_CLASS(cFractalAmazingSurfMod3)
FRACTAL_CLASS(cFractalAmazingSurfMod4)
FRACTAL_CLASS(cFractalAmazingSurfMulti)
FRACTAL_CLASS(cFractalBenesi)
FRACTAL_CLASS(cFractalBenesiMagTransforms)
FRACTAL_CLASS(cFractalBenesiPineTree)
FRACTAL_CLASS(cFractalBenesiPwr2Mandelbulb)
FRACTAL_CLASS(cFractalBenesiT1PineTree)
FRACTAL_CLASS(cFractalBoxFold4dBulbPow2)
FRACTAL_CLASS(cFractalBoxFoldBulbMenger)
FRACTAL_CLASS(cFractalBoxFoldBulbPow2)
FRACTAL_CLASS(cFractalBoxFoldBulbPow2V2)
FRACTAL_CLASS(cFractalBoxFoldBulbPow2V3)
FRACTAL_CLASS(cFractalBoxFoldBulbV4)
FRACTAL_CLASS(cFractalBoxFoldQuat)
FRACTAL_CLASS(cFractalBristorbrot)
FRACTAL_CLASS(cFractalBristorbrot2)
FRACTAL_CLASS(cFractalBristorbrot4d)
FRACTAL_CLASS(cFractalBuffalo)
FRACTAL_CLASS(cFractalCoastalbrot)
FRACTAL_CLASS(cFractalCollatz)
FRACTAL_CLASS(cFractalCollatzMod)
FRACTAL_CLASS(cFractalCustom)
FRACTAL_CLASS(cFractalDIFSAmazingIfs)
FRACTAL_CLASS(cFractalDIFSBoxDiagonalV1)
FRACTAL_CLASS(cFractalDIFSBoxDiagonalV3)
FRACTAL_CLASS(cFractalDIFSBoxV1)
FRACTAL_CLASS(cFractalDIFSCylinder)
FRACTAL_CLASS(cFractalDIFSEllipsoid)
FRACTAL_CLASS(cFractalDIFSHextgrid2)
FRACTAL_CLASS(cFractalDIFSMenger)
FRACTAL_CLASS(cFractalDIFSMsltoeDonut)
FRACTAL_CLASS(cFractalDIFSMultiV1)
FRACTAL_CLASS(cFractalDIFSPrism)
FRACTAL_CLASS(cFractalDIFSSphere)
FRACTAL_CLASS(cFractalDIFSTorus)
FRACTAL_CLASS(cFractalEiffieMsltoe)
FRACTAL_CLASS(cFractalFoldBoxMod1)
FRACTAL_CLASS(cFractalFoldCutCube)
FRACTAL_CLASS(cFractalGeneralizedFoldBox)
FRACTAL_CLASS(cFractalHypercomplex)
FRACTAL_CLASS(cFractalHypercomplexV2)
FRACTAL_CLASS(cFractalIdes)
FRACTAL_CLASS(cFractalIdes2)
FRACTAL_CLASS(cFractalIfsGen)
FRACTAL_CLASS(cFractalIfsXY)
FRACTAL_CLASS(cFractalIqBulb)
FRACTAL_CLASS(cFractalJosKleinian)
FRACTAL_CLASS(cFractalJosKleinianV2)
FRACTAL_CLASS(cFractalJosKleinianV3)
FRACTAL_CLASS(cFractalJosKleinianV4)
FRACTAL_CLASS(cFractalKaleidoscopicIfs)
FRACTAL_CLASS(cFractalKalisets1)
FRACTAL_CLASS(cFractalKnotV1)
FRACTAL_CLASS(cFractalKnotV2)
FRACTAL_CLASS(cFractalKoch)
FRACTAL_CLASS(cFractalKochV2)
FRACTAL_CLASS(cFractalKochV3)
FRACTAL_CLASS(cFractalKochV4)
FRACTAL_CLASS(cFractalLkmitch)
FRACTAL_CLASS(cFractalMakin3d2)
FRACTAL_CLASS(cFractalMandalayBoxV1)
FRACTAL_CLASS(cFractalMandalayBoxV2)
FRACTAL_CLASS(cFractalMandalayKIFS)
FRACTAL_CLASS(cFractalMandelbar)
FRACTAL_CLASS(cFractalMandelbarV2)
FRACTAL_CLASS(cFractalMandelbox)
FRACTAL_CLASS(cFractalMandelboxFast)
FRACTAL_CLASS(cFractalMandelboxMenger)
FRACTAL_CLASS(cFractalMandelboxSmooth)
FRACTAL_CLASS(cFractalMandelboxVariable)
FRACTAL_CLASS(cFractalMandelboxVaryScale4d)
FRACTAL_CLASS(cFractalMandelbulb)
FRACTAL_CLASS(cFractalMandelbulb2)
FRACTAL_CLASS(cFractalMandelbulb3)
FRACTAL_CLASS(cFractalMandelbulb4)
FRACTAL_CLASS(cFractalMandelbulbAbs)
FRACTAL_CLASS(cFractalMandelbulbAbsPower2)
FRACTAL_CLASS(cFractalMandelbulbAtan2Power2)
FRACTAL_CLASS(cFractalMandelbulbBermarte)
FRACTAL_CLASS(cFractalMandelbulbEye)
FRACTAL_CLASS(cFractalMandelbulbIqPow8)
FRACTAL_CLASS(cFractalMandelbulbIqV2)
FRACTAL_CLASS(cFractalMandelbulbJuliabulb)
FRACTAL_CLASS(cFractalMandelbulbKali)
FRACTAL_CLASS(cFractalMandelbulbKaliMulti)
FRACTAL_CLASS(cFractalMandelbulbKosalos)
FRACTAL_CLASS(cFractalMandelbulbKosalosV2)
FRACTAL_CLASS(cFractalMandelbulbLambda)
FRACTAL_CLASS(cFractalMandelbulbMulti)
FRACTAL_CLASS(cFractalMandelbulbMulti2)
FRACTAL_CLASS(cFractalMandelbulbPlusZ)
FRACTAL_CLASS(cFractalMandelbulbPow2V1)
FRACTAL_CLASS(cFractalMandelbulbPow2V2)
FRACTAL_CLASS(cFractalMandelbulbPow2V3)
FRACTAL_CLASS(cFractalMandelbulbPower1234)
FRACTAL_CLASS(cFractalMandelbulbPower2)
FRACTAL_CLASS(cFractalMandelbulbPupuku)
FRACTAL_CLASS(cFractalMandelbulbQuadrat)
FRACTAL_CLASS(cFractalMandelbulbQuat)
FRACTAL_CLASS(cFractalMandelbulbSinCos)
FRACTAL_CLASS(cFractalMandelbulbSinCosV2)
FRACTAL_CLASS(cFractalMandelbulbSinCosV3)
FRACTAL_CLASS(cFractalMandelbulbSinCosV4)
FRACTAL_CLASS(cFractalMandelbulbTails)
FRACTAL_CLASS(cFractalMandelbulbTailsV2)
FRACTAL_CLASS(cFractalMandelbulbVaryPowerV1)
FRACTAL_CLASS(cFractalMandelcup)
FRACTAL_CLASS(cFractalMandelnest)
FRACTAL_CLASS(cFractalMandelnest4d)
FRACTAL_CLASS(cFractalMandelnestFull)
FRACTAL_CLASS(cFractalMandelnestV2)
FRACTAL_CLASS(cFractalMandeltorus)
FRACTAL_CLASS(cFractalMandeltorusV2)
FRACTAL_CLASS(cFractalMenger3)
FRACTAL_CLASS(cFractalMenger3M3d)
FRACTAL_CLASS(cFractalMenger4d)
FRACTAL_CLASS(cFractalMenger4dMod1)
FRACTAL_CLASS(cFractalMenger4dMod2)
FRACTAL_CLASS(cFractalMengerChebyshev)
FRACTAL_CLASS(cFractalMengerCrossKIFS)
FRACTAL_CLASS(cFractalMengerCrossMod1)
FRACTAL_CLASS(cFractalMengerMiddleMod)
FRACTAL_CLASS(cFractalMengerMod1)
FRACTAL_CLASS(cFractalMengerOcto)
FRACTAL_CLASS(cFractalMengerPolyFold)
FRACTAL_CLASS(cFractalMengerPrismShape)
FRACTAL_CLASS(cFractalMengerPrismShape2)
FRACTAL_CLASS(cFractalMengerPwr2Poly)
FRACTAL_CLASS(cFractalMengerPyramid)
FRACTAL_CLASS(cFractalMengerSmooth)
FRACTAL_CLASS(cFractalMengerSmoothChebyshev)
FRACTAL_CLASS(cFractalMengerSmoothMod1)
FRACTAL_CLASS(cFractalMengerSponge)
FRACTAL_CLASS(cFractalMengerV2)
FRACTAL_CLASS(cFractalMengerV3)
FRACTAL_CLASS(cFractalMengerV4)
FRACTAL_CLASS(cFractalMengerV5)
FRACTAL_CLASS(cFractalMengerV6)
FRACTAL_CLASS(cFractalMengerV7)
FRACTAL_CLASS(cFractalMixPinski4d)
FRACTAL_CLASS(cFractalModulusMandelbulb)
FRACTAL_CLASS(cFractalModulusMengerSponge)
FRACTAL_CLASS(cFractalMsltoeDonut)
FRACTAL_CLASS(cFractalMsltoeSym2Mod)
FRACTAL_CLASS(cFractalMsltoeSym3Mod)
FRACTAL_CLASS(cFractalMsltoeSym3Mod2)
FRACTAL_CLASS(cFractalMsltoeSym3Mod3)
FRACTAL_CLASS(cFractalMsltoeSym3Mod4)
FRACTAL_CLASS(cFractalMsltoeSym3Mod5)
FRACTAL_CLASS(cFractalMsltoeSym3Mod6)
FRACTAL_CLASS(cFractalMsltoeSym4Mod)
FRACTAL_CLASS(cFractalMsltoeSym4Mod1)
FRACTAL_CLASS(cFractalMsltoeToroidal)
FRACTAL_CLASS(cFractalMsltoeToroidalMulti)
FRACTAL_CLASS(cFractalMsltoeToroidalV2)
FRACTAL_CLASS(cFractalNewtonPow3)
FRACTAL_CLASS(cFractalOctahedron)
FRACTAL_CLASS(cFractalPseudoKleinian)
FRACTAL_CLASS(cFractalPseudoKleinian4d)
FRACTAL_CLASS(cFractalPseudoKleinianMod1)
FRACTAL_CLASS(cFractalPseudoKleinianMod2)
FRACTAL_CLASS(cFractalPseudoKleinianMod3)
FRACTAL_CLASS(cFractalPseudoKleinianMod4)
FRACTAL_CLASS(cFractalPseudoKleinianMod5)
FRACTAL_CLASS(cFractalPseudoKleinianMod6)
FRACTAL_CLASS(cFractalPseudoKleinianStdDE)
FRACTAL_CLASS(cFractalQuaternion)
FRACTAL_CLASS(cFractalQuaternion3d)
FRACTAL_CLASS(cFractalQuaternion4d)
FRACTAL_CLASS(cFractalQuaternionCubic4d)
FRACTAL_CLASS(cFractalQuickDudley)
FRACTAL_CLASS(cFractalQuickDudleyMod)
FRACTAL_CLASS(cFractalRiemannBulbMsltoeMod2)
FRACTAL_CLASS(cFractalRiemannSphereHoboldMulti)
FRACTAL_CLASS(cFractalRiemannSphereHoboldPow4)
FRACTAL_CLASS(cFractalRiemannSphereHoboldPow8)
FRACTAL_CLASS(cFractalRiemannSphereMsltoe)
FRACTAL_CLASS(cFractalRiemannSphereMsltoeM3d)
FRACTAL_CLASS(cFractalRiemannSphereMsltoeV1)
FRACTAL_CLASS(cFractalRiemannSphereMsltoeV2)
FRACTAL_CLASS(cFractalScatorPower2)
FRACTAL_CLASS(cFractalScatorPower2Imaginary)
FRACTAL_CLASS(cFractalScatorPower2Real)
FRACTAL_CLASS(cFractalScatorPower2StdR)
FRACTAL_CLASS(cFractalScatorTest)
FRACTAL_CLASS(cFractalSierpinski3d)
FRACTAL_CLASS(cFractalSierpinski3dV2)
FRACTAL_CLASS(cFractalSierpinski3dV3)
FRACTAL_CLASS(cFractalSierpinski3dV4)
FRACTAL_CLASS(cFractalSierpinski4d)
FRACTAL_CLASS(cFractalSphereCluster)
FRACTAL_CLASS(cFractalSphereClusterV2)
FRACTAL_CLASS(cFractalSphereClusterV3)
FRACTAL_CLASS(cFractalSpheretree)
FRACTAL_CLASS(cFractalSpheretreeV2)
FRACTAL_CLASS(cFractalSpheretreeV4)
FRACTAL_CLASS(cFractalSpheretreeV5)
FRACTAL_CLASS(cFractalTesting)
FRACTAL_CLASS(cFractalTesting4d)
FRACTAL_CLASS(cFractalTestingLog)
FRACTAL_CLASS(cFractalTestingTransform)
FRACTAL_CLASS(cFractalTestingTransform2)
FRACTAL_CLASS(cFractalTinkerTowers)
FRACTAL_CLASS(cFractalTransfAbsAddConditional)
FRACTAL_CLASS(cFractalTransfAbsAddConditional2)
FRACTAL_CLASS(cFractalTransfAbsAddConditional4d)
FRACTAL_CLASS(cFractalTransfAbsAddConstant)
FRACTAL_CLASS(cFractalTransfAbsAddConstant4d)
FRACTAL_CLASS(cFractalTransfAbsAddConstantV2)
FRACTAL_CLASS(cFractalTransfAbsAddMulti)
FRACTAL_CLASS(cFractalTransfAbsAddMulti4d)
FRACTAL_CLASS(cFractalTransfAbsAddTgladFold)
FRACTAL_CLASS(cFractalTransfAbsAddTgladFold4d)
FRACTAL_CLASS(cFractalTransfAbsRecFoldXY)
FRACTAL_CLASS(cFractalTransfAddConstant)
FRACTAL_CLASS(cFractalTransfAddConstant4d)
FRACTAL_CLASS(cFractalTransfAddConstantMod1)
FRACTAL_CLASS(cFractalTransfAddConstantMod2)
FRACTAL_CLASS(cFractalTransfAddConstantMod3)
FRACTAL_CLASS(cFractalTransfAddConstantRotV1)
FRACTAL_CLASS(cFractalTransfAddConstantVaryV1)
FRACTAL_CLASS(cFractalTransfAddCpixel)
FRACTAL_CLASS(cFractalTransfAddCpixel4d)
FRACTAL_CLASS(cFractalTransfAddCpixelAxisSwap)
FRACTAL_CLASS(cFractalTransfAddCpixelCxCyAxisSwap)
FRACTAL_CLASS(cFractalTransfAddCpixelInvert)
FRACTAL_CLASS(cFractalTransfAddCpixelRotated)
FRACTAL_CLASS(cFractalTransfAddCpixelScator)
FRACTAL_CLASS(cFractalTransfAddCpixelSinOrCos)
FRACTAL_CLASS(cFractalTransfAddCpixelSphereFold)
FRACTAL_CLASS(cFractalTransfAddCpixelSymmetrical)
FRACTAL_CLASS(cFractalTransfAddCpixelTile)
FRACTAL_CLASS(cFractalTransfAddCpixelVaryV1)
FRACTAL_CLASS(cFractalTransfAddExp2Z)
FRACTAL_CLASS(cFractalTransfAddNorm)
FRACTAL_CLASS(cFractalTransfAddScaleRotate)
FRACTAL_CLASS(cFractalTransfAddSphericalInvert)
FRACTAL_CLASS(cFractalTransfBenesiCubeSphere)
FRACTAL_CLASS(cFractalTransfBenesiMagBackward)
FRACTAL_CLASS(cFractalTransfBenesiMagForward)
FRACTAL_CLASS(cFractalTransfBenesiSphereCube)
FRACTAL_CLASS(cFractalTransfBenesiT1)
FRACTAL_CLASS(cFractalTransfBenesiT1Mod)
FRACTAL_CLASS(cFractalTransfBenesiT2)
FRACTAL_CLASS(cFractalTransfBenesiT3)
FRACTAL_CLASS(cFractalTransfBenesiT4)
FRACTAL_CLASS(cFractalTransfBenesiT5b)
FRACTAL_CLASS(cFractalTransfBlockify)
FRACTAL_CLASS(cFractalTransfBlockifyV2)
FRACTAL_CLASS(cFractalTransfBoxFold)
FRACTAL_CLASS(cFractalTransfBoxFold4d)
FRACTAL_CLASS(cFractalTransfBoxFold4dTglad)
FRACTAL_CLASS(cFractalTransfBoxFoldVaryV1)
FRACTAL_CLASS(cFractalTransfBoxFoldXYZ)
FRACTAL_CLASS(cFractalTransfBoxOffset)
FRACTAL_CLASS(cFractalTransfBoxTiling4d)
FRACTAL_CLASS(cFractalTransfBoxTilingV2)
FRACTAL_CLASS(cFractalTransfBoxTilingV3)
FRACTAL_CLASS(cFractalTransfBoxWrap4d)
FRACTAL_CLASS(cFractalTransfCayley2V1)
FRACTAL_CLASS(cFractalTransfClamp4d)
FRACTAL_CLASS(cFractalTransfDEControls)
FRACTAL_CLASS(cFractalTransfDELinearCube)
FRACTAL_CLASS(cFractalTransfDiagonalFold)
FRACTAL_CLASS(cFractalTransfDIFSAmazingIfs)
FRACTAL_CLASS(cFractalTransfDIFSBox)
FRACTAL_CLASS(cFractalTransfDIFSBoxFrame)
FRACTAL_CLASS(cFractalTransfDIFSBoxV2)
FRACTAL_CLASS(cFractalTransfDIFSBoxV3)
FRACTAL_CLASS(cFractalTransfDIFSCayley2)
FRACTAL_CLASS(cFractalTransfDIFSChessboard)
FRACTAL_CLASS(cFractalTransfDIFSClipCustom)
FRACTAL_CLASS(cFractalTransfDIFSClipPlane)
FRACTAL_CLASS(cFractalTransfDIFSCylinder)
FRACTAL_CLASS(cFractalTransfDIFSCylinderV2)
FRACTAL_CLASS(cFractalTransfDIFSDiamond)
FRACTAL_CLASS(cFractalTransfDIFSEllipsoid)
FRACTAL_CLASS(cFractalTransfDIFSGearV1)
FRACTAL_CLASS(cFractalTransfDIFSGrid)
FRACTAL_CLASS(cFractalTransfDIFSGridV2)
FRACTAL_CLASS(cFractalTransfDIFSGridV3)
FRACTAL_CLASS(cFractalTransfDIFSHeart)
FRACTAL_CLASS(cFractalTransfDIFSHelix)
FRACTAL_CLASS(cFractalTransfDIFSHelixMenger)
FRACTAL_CLASS(cFractalTransfDIFSHelixV2)
FRACTAL_CLASS(cFractalTransfDIFSHexprism)
FRACTAL_CLASS(cFractalTransfDIFSHexprismV2)
FRACTAL_CLASS(cFractalTransfDIFSHextgrid2)
FRACTAL_CLASS(cFractalTransfDIFSHybridColor)
FRACTAL_CLASS(cFractalTransfDIFSPiriform)
FRACTAL_CLASS(cFractalTransfDIFSPolyhedra)
FRACTAL_CLASS(cFractalTransfDIFSPolyhedraV2)
FRACTAL_CLASS(cFractalTransfDIFSPrism)
FRACTAL_CLASS(cFractalTransfDIFSPrismV2)
FRACTAL_CLASS(cFractalTransfDIFSSphere)
FRACTAL_CLASS(cFractalTransfDIFSSphereGrid)
FRACTAL_CLASS(cFractalTransfDIFSSphereGridV2)
FRACTAL_CLASS(cFractalTransfDIFSSphereGridV3)
FRACTAL_CLASS(cFractalTransfDIFSSpring)
FRACTAL_CLASS(cFractalTransfDIFSTorus)
FRACTAL_CLASS(cFractalTransfDIFSTorusGrid)
FRACTAL_CLASS(cFractalTransfDIFSTorusMenger)
FRACTAL_CLASS(cFractalTransfDIFSTorusTwist)
FRACTAL_CLASS(cFractalTransfDIFSTorusV2)
FRACTAL_CLASS(cFractalTransfDIFSTorusV3)
FRACTAL_CLASS(cFractalTransfDIFSTriGrid)
FRACTAL_CLASS(cFractalTransfDotFold)
FRACTAL_CLASS(cFractalTransfFoldingTetra3d)
FRACTAL_CLASS(cFractalTransfGnarl)
FRACTAL_CLASS(cFractalTransfHybridColor)
FRACTAL_CLASS(cFractalTransfHybridColor2)
FRACTAL_CLASS(cFractalTransfInitial4d)
FRACTAL_CLASS(cFractalTransfInvCylindrical)
FRACTAL_CLASS(cFractalTransfIterationWeight)
FRACTAL_CLASS(cFractalTransfIterationWeight4d)
FRACTAL_CLASS(cFractalTransfLinCombineCXYZ)
FRACTAL_CLASS(cFractalTransfLowResMode)
FRACTAL_CLASS(cFractalTransfMandalayFold4d)
FRACTAL_CLASS(cFractalTransfMandalayFoldV1)
FRACTAL_CLASS(cFractalTransfMandalayFoldV2)
FRACTAL_CLASS(cFractalTransfMengerFold)
FRACTAL_CLASS(cFractalTransfMengerFoldV2)
FRACTAL_CLASS(cFractalTransfMultipleAngle)
FRACTAL_CLASS(cFractalTransfNegAbsAddConstant)
FRACTAL_CLASS(cFractalTransfOctoFold)
FRACTAL_CLASS(cFractalTransfOffsetSCurve4d)
FRACTAL_CLASS(cFractalTransfParabFold)
FRACTAL_CLASS(cFractalTransfPlatonicSolid)
FRACTAL_CLASS(cFractalTransfPolyFoldAtan)
FRACTAL_CLASS(cFractalTransfPolyFoldAtan2)
FRACTAL_CLASS(cFractalTransfPolyFoldAtan2Iter)
FRACTAL_CLASS(cFractalTransfPolyFoldSymMulti)
FRACTAL_CLASS(cFractalTransfPolyFoldSymXY)
FRACTAL_CLASS(cFractalTransfPolyXYFoldV1)
FRACTAL_CLASS(cFractalTransfPwr2Polynomial)
FRACTAL_CLASS(cFractalTransfQuadraticFold4d)
FRACTAL_CLASS(cFractalTransfQuaternionFold)
FRACTAL_CLASS(cFractalTransfRPower)
FRACTAL_CLASS(cFractalTransfReciprocal3)
FRACTAL_CLASS(cFractalTransfReciprocal4d)
FRACTAL_CLASS(cFractalTransfRotateAboutVec3)
FRACTAL_CLASS(cFractalTransfRotation)
FRACTAL_CLASS(cFractalTransfRotation4d)
FRACTAL_CLASS(cFractalTransfRotationChebyshev)
FRACTAL_CLASS(cFractalTransfRotationFolding)
FRACTAL_CLASS(cFractalTransfRotationFoldingPlane)
FRACTAL_CLASS(cFractalTransfRotationIterControls)
FRACTAL_CLASS(cFractalTransfRotationM3d)
FRACTAL_CLASS(cFractalTransfRotationVaryV1)
FRACTAL_CLASS(cFractalTransfRpow3)
FRACTAL_CLASS(cFractalTransfScale)
FRACTAL_CLASS(cFractalTransfScale3d)
FRACTAL_CLASS(cFractalTransfScale4d)
FRACTAL_CLASS(cFractalTransfScaleOffset)
FRACTAL_CLASS(cFractalTransfScaleOffsetV2)
FRACTAL_CLASS(cFractalTransfScaleVaryMulti)
FRACTAL_CLASS(cFractalTransfScaleVaryV1)
FRACTAL_CLASS(cFractalTransfScaleVaryV212)
FRACTAL_CLASS(cFractalTransfScaleVaryVCL)
FRACTAL_CLASS(cFractalTransfSinAdd)
FRACTAL_CLASS(cFractalTransfSinAndCos)
FRACTAL_CLASS(cFractalTransfSinAndCosMax)
FRACTAL_CLASS(cFractalTransfSinOrCos)
FRACTAL_CLASS(cFractalTransfSinTan)
FRACTAL_CLASS(cFractalTransfSinYM3d)
FRACTAL_CLASS(cFractalTransfSincos)
FRACTAL_CLASS(cFractalTransfSincosHelix)
FRACTAL_CLASS(cFractalTransfSincosV2)
FRACTAL_CLASS(cFractalTransfSmooth)
FRACTAL_CLASS(cFractalTransfSmoothV2)
FRACTAL_CLASS(cFractalTransfSphericalCoordInvs)
FRACTAL_CLASS(cFractalTransfSphericalFold)
FRACTAL_CLASS(cFractalTransfSphericalFold4d)
FRACTAL_CLASS(cFractalTransfSphericalFold4dV2)
FRACTAL_CLASS(cFractalTransfSphericalFoldAbox)
FRACTAL_CLASS(cFractalTransfSphericalFoldCHS)
FRACTAL_CLASS(cFractalTransfSphericalFoldCuboid)
FRACTAL_CLASS(cFractalTransfSphericalFoldParab)
FRACTAL_CLASS(cFractalTransfSphericalFoldPnorm)
FRACTAL_CLASS(cFractalTransfSphericalFoldSmooth)
FRACTAL_CLASS(cFractalTransfSphericalFoldV1)
FRACTAL_CLASS(cFractalTransfSphericalFoldV2)
FRACTAL_CLASS(cFractalTransfSphericalFoldV3)
FRACTAL_CLASS(cFractalTransfSphericalFoldVaryV1)
FRACTAL_CLASS(cFractalTransfSphericalFoldVaryVCL)
FRACTAL_CLASS(cFractalTransfSphericalFoldXYZBias)
FRACTAL_CLASS(cFractalTransfSphericalInv)
FRACTAL_CLASS(cFractalTransfSphericalInvC)
FRACTAL_CLASS(cFractalTransfSphericalInvPnorm)
FRACTAL_CLASS(cFractalTransfSphericalInvV2)
FRACTAL_CLASS(cFractalTransfSphericalInvV3)
FRACTAL_CLASS(cFractalTransfSphericalOffset)
FRACTAL_CLASS(cFractalTransfSphericalOffsetVCL)
FRACTAL_CLASS(cFractalTransfSphericalPwrFold)
FRACTAL_CLASS(cFractalTransfStepXY)
FRACTAL_CLASS(cFractalTransfSupershape)
FRACTAL_CLASS(cFractalTransfSurfBoxFold)
FRACTAL_CLASS(cFractalTransfSurfBoxFoldV2)
FRACTAL_CLASS(cFractalTransfSurfBoxFoldV24d)
FRACTAL_CLASS(cFractalTransfSurfFoldMulti)
FRACTAL_CLASS(cFractalTransfZvectorAxisSwap)
FRACTAL_CLASS(cFractalVicsek)
FRACTAL_CLASS(cFractalXenodreambuie)
FRACTAL_CLASS(cFractalXenodreambuieV2)
FRACTAL_CLASS(cFractalXenodreambuieV3)

#endif /* MANDELBULBER2_FORMULA_DEFINITION_ALL_FRACTAL_DEFINITIONS_H_ */
